package com.btc.ep.base.dal.tests.it;

import java.io.File;
import java.util.Collection;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import com.btc.ep.base.bl.ModelElement;
import com.btc.ep.base.bl.Profile;
import com.btc.ep.base.bl.impl.ProfileImpl;
import com.btc.ep.base.dal.impl.BaseRepository;
import com.btc.ep.base.dal.internal.BaseRepositoryImpl;

/**
 * This class tests the DAL save and load operations.
 */

public class IT_DALSaveAndLoadTest extends BaseTest {

	/**
	 * initializes resources before running all tests
	 * 
	 * @throws Exception
	 *             anything
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * destroys resources after running all tests
	 * 
	 * @throws Exception
	 *             anything
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		destroyPersistenceService();
	}

	/**
	 * initializes before running a particular test
	 * 
	 * @throws Exception
	 *             anything
	 */
	@Before
	public void setUp() throws Exception {
		deleteDatabase();
	}

	/**
	 * destroys after running a particular test
	 * 
	 * @throws Exception
	 *             anything
	 */
	@After
	public void tearDown() throws Exception {
	}

	/**
	 * Saves a profile, loads a profile and compares the saved profile to the
	 * load profile. A log in the console explains the tree comparing.
	 *
	 * @throws Exception
	 *             anything
	 */
	@Test
	public void saveProfileAndLoadProfileAndComparingProfilesTest()
			throws Exception {

		Profile profile = new ProfileImpl();

		profile.setFilePath(new File("abc.txt"));
		profile.setName("profile");

		getPersistenceService().persist(profile);

		BaseRepository<ModelElement> baseRepository = new BaseRepositoryImpl();

		baseRepository.update(profile);

		// store in DataBaseFile [commit();]
		baseRepository.save();

		getPersistenceService().clear();

		Collection<ProfileImpl> res = baseRepository.findAll(ProfileImpl.class);

		Profile profile2 = res.iterator().next();

//		Verifier verifier = new Verifier();
//		verifier.start(profile, profile2);

		getPersistenceService().remove(profile2);
	}

}
